CGEQR2(3f)

NAME
CGEQR2 - a QR factorization of a complex m by n matrix A

SYNOPSIS

SUBROUTINE CGEQR2(
    M, N, A, LDA, TAU, WORK, INFO )

INTEGER
    INFO, LDA, M, N

COMPLEX
    A( LDA, * ), TAU( * ), WORK( * )

PURPOSE
CGEQR2 computes a QR factorization of a complex m by n matrix A: A = Q * R.

ARGUMENTS

M       (input) INTEGER
    The number of rows of the matrix A. M >= 0.

N       (input) INTEGER
    The number of columns of the matrix A. N >= 0.

A       (input/output) COMPLEX array, dimension (LDA,N)
    On entry, the m by n matrix A. On exit, the elements on and above the diagonal of the array contain the min(m,n) by n upper trapezoidal matrix R (R is upper triangular if m >= n); the elements below the diagonal, with the array TAU, represent the unitary matrix Q as a product of elementary reflectors (see Further Details). LDA (input) INTEGER The leading dimension of the array A. LDA >= max(1,M).

TAU     (output) COMPLEX array, dimension (min(M,N))
    The scalar factors of the elementary reflectors (see Further Details).

WORK    (workspace) COMPLEX array, dimension (N)

INFO    (output) INTEGER
    = 0: successful exit
    < 0: if INFO = -i, the i-th argument had an illegal value

FURTHER DETAILS
The matrix Q is represented as a product of elementary reflectors
   Q = H(1) H(2) . . . H(k), where k = min(m,n).
Each H(i) has the form
   H(i) = I - tau * v * v'
where tau is a complex scalar, and v is a complex vector with v(1:i-1) = 0 and v(i) = 1; v(i+1:m) is stored on exit in A(i+1:m,i), and tau in TAU(i).